<?php

namespace App\Http\Controllers\BackEnd;

use App\Http\Controllers\Controller;
use App\Models\boycott_company;
use App\Models\boycott_companyType;
use Illuminate\Support\Facades\DB;
// use Yajra\DataTables\DataTables;
use App\Models\User;
use Carbon\Carbon;
use Exception;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use PhpParser\Node\Stmt\TryCatch;

class boycott_companyController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function get_category($id)
    {
        $category_sub = boycott_company::where('id', $id)->get();
        echo '<select class="form-control" name="sub_place">';
        foreach ($category_sub as  $value) {
            echo '<option value="' . $value->id . '">' . $value->name . '</option>';
        }
        echo '</select>';
    }
    public function get_category_discounts($id)
    {
        $category_sub = boycott_company::where('id', $id)->get();
        foreach ($category_sub as  $value) {

            echo '<option value="' . $value->id . '">' . $value->name . '</option>';
        }
    }
    public function boycotts_eye($id)
    {
        $affected = boycott_company::find($id);
        if ($affected->active == 1) {
            $affected->active = 0;
            $affected->save();
            echo ' <i style="color: red;" class="ti-eye"></i>';
        } else {
            $affected->active = 1;
            $affected->save();
            echo '<i class="ti-eye"></i>';
        }
    }
    public function index1()
    {
        $boycotts = boycott_company::all();
        $users= User::all();
        return view('back.boycotts.index1', compact(['boycotts','users']));
    }
    public function boycott_companyall()
    {
        $boycotts = boycott_company::all();
        $users= User::all();
        return view('back.boycotts.boycott_companyall', compact(['boycotts','users']));
    }
    public function create_boycott_company_type_id($id,$name)
    {
        // $boycotts_type = boycott_companyType::find($id);
        // dd($id);
        // $boycotts_type = boycott_company::where('boycott_company_type_id',$id)->with('user')->get();
        // $users= User::where('active',0)->get();
        // $users= User::all();
        // $boycotts_type = boycott_company::where('boycott_company_type_id',$id)->get();
        // $users= User::where('active',0)->get();
        // $users= User::all();
        // DB::table('user')
        //     ->select('id','name')
        //     ->whereNotIn('id', DB::table('boycotts')->select('user_id')->where('boycott_company_type_id', '=', $id)->get()->toArray())->get();
        // $id=1;
        // $boycotts_type = DB::table('users')->select('id','name')->whereNotIn('id', DB::table('boycotts')->select('user_id')->where('id', '=', $id)->get()->toArray())->get();
        $boycotts_type =  DB::table('users')->select('id','name')->whereNotIn('id', boycott_company::where("boycott_company_type_id",$id)->pluck("user_id")->toArray())->get();
        return view('back.boycotts.table', compact(['boycotts_type']));
    }
    public function boycott_companyall1()
    {
        $boycotts = boycott_company::all();
        $users= User::all();
        return view('back.boycotts.boycotts', compact(['boycotts','users']));
    }
    public function index()
    {
        $boycotts = boycott_company::all();
        return view('back.boycotts.index', compact('boycotts'));
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {


        try {
            $users = User::where('active', 1)->get();
            $Shift = Shift::all();
           echo ' <div class="form-group">
           <label > اسم الموطف </label>
           <select class="form-control select2 select2-hidden-accessible" id="name" name="name"  style=" width: 100%">
           <option> اختار الموطف </option>';
           foreach ($users as $values) {
               echo '<option value="' . $values->id . '">' . $values->name . '</option>';
           }
           echo ' </select></div>
           <div class="form-group">
           <label > تاريخ الحضور  </label>
           <input  id="date_entry" name="date_entry"  class="form-control"   type="date"  >
           </div>
           <div class="form-group">
           <label >الحضور   </label>
           <input  id="start_entry" name="start_entry"  class="form-control"   type="time"  >
         </div>
        <div class="form-group">
         <label > الانصراف </label>
         <input  id="start_exit" name="start_exit"  class="form-control" type="time" >
         </div>';
         return 1;
        } catch (\Throwable $th) {
            //throw $th;
            return 0;
        }


    }
    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
     public function boycott_companyall_store(Request $request)
     {
        $validator = Validator::make($request->all(), [
            'users_id' => 'required',
            'boycott_company_type_id' => 'required',
            // 'date_entry' => 'required',
            // 'start_entry' => 'required',
        ]);
        if ($validator->fails()) {
            return response()->json(['error'=>$validator->errors()], 401);
        }
        // $boycott_company_type = boycott_companyType::find($request->boycott_company_type_id,)->first();
        //   $shift = Auth::user()->shift()->first();
        //    $checkin = boycott_company::where(['user_id' =>$request->id,'boycott_company_type_id' =>$request->boycott_company_type_id])->first();
        // $this->validate($request, [
        //     'users_id' => 'required',
        //     // 'date' => 'required|unique:boycotts,date,' . $request->id,
        //     'start_entry' => 'required',
        //     'date_entry' => 'required',
        //   ]);
        $boycott_company_type = boycott_companyType::find($request->boycott_company_type_id)->first();
        if ($request['users_id'] != null) {
            foreach ($request['users_id'] as $posithon) {
                //    $checkin = boycott_company::where(['user_id' =>$request->id,'boycott_company_type_id' =>$request->boycott_company_type_id])->first();
                boycott_company::create([
                    'user_id' =>(int) $posithon,
                    'boycott_company_type_id' =>$request->boycott_company_type_id,
                    'date' => $boycott_company_type->date,
                    'time_in' => $boycott_company_type->enter_time,
                    'type' => 'checkin',
                    'login' => 'web',
                    'mobile_id' =>  Auth::user()->id,
                    'latitude' => $boycott_company_type->latitude,
                    'longitude' => $boycott_company_type->longitude,
                ]);
            }
        }
     }
    public function store(Request $request)
    {
            $this->validate($request, [
                'name' => 'required',
                // 'date' => 'required|unique:boycotts,date,' . $request->id,
                // 'place' => 'required',
                // 'type_lecture' => 'required',
                // 'start_entry' => 'required',
                'date_entry' => 'required',
                // 'start_exit' => 'required',
              ]);
            //   $shift = Auth::user()->shift()->first();

             boycott_company::create([
                'user_id' =>$request->name,
                // 'shift_id' =>$shift->id,
                'date' => $request->date_entry,
                'time_in' => $request->start_entry,//'12:00:00',
                'type' => 'checkin',//'12:00:00',
                'login' => 'web',
                // 'place' =>'المدير',
                // 'place' => $request->place,
                // 'type_lecture' => $request->type_lecture,
                'mobile_id' =>  Auth::user()->id,
                // 'time_in' => Carbon::now()->format('H:i:s'),
                'latitude' => $request->latitude,
                'longitude' => $request->longitude,
                // 'description' => 'A',
            ]);

        // $this->validate($request, [
        //     'name' => 'required|string|unique:sub_categories,name',
        //     'place' => 'required',
        //     'image' => 'required',
        // ]);
        // $boycotts = new boycott_company();
        // $boycotts->place = $request->place;
        // $boycotts->name = $request->name;
        // $boycotts->name_en = $request->name_en;
        // if ($request->image != null) {
        //     $truck_img = time() . '.' . $request->image->extension();
        //     $request->image->move(public_path('images/boycotts'), $truck_img);
        //     $boycotts->image = $truck_img;
        // } else {
        //     $boycotts->image = 'duifult.png';
        // }
        // if ($request->banner != null) {
        //     $truck_banner = time() . '.' . $request->banner->extension();
        //     $request->banner->move(public_path('images/banners'), $truck_banner);
        //     $boycotts->banner = $truck_banner;
        // } else {
        //     $boycotts->image = '../duifult.png';
        // }
        // $boycotts->save();
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Admin\boycott_company  $boycott_company
     * @return \Illuminate\Http\Response
     */
    public function show()
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Admin\boycott_company  $boycott_company
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $boycotts = boycott_company::find($id);
        echo '<div class="form-group">
         <input type="hidden"  id="id" name="id"  value="' . $id . '">
           <div class="form-group">
           <label > أسم الفرعي العربي  </label>
            <input id="name" name="name" type="text"value="' . $boycotts->name . '" class="form-control" placeholder="أسم  الفرعي  العربي"></div>
            <div class="form-group">
            <label > أسم الفرعي الانجليزي  </label>
            <input id="name" name="name_en" type="text" value="' . $boycotts->name_en . '" class="form-control" placeholder="أسم الفرعي الانجليزي "></div>
            <div class="form-group">
           <label > صورة القسم الفرعي   </label>
           <img class="wp-post-image img-rounded" src="' . asset('images/boycotts') . '/' . $boycotts->image . '" alt="Cinque Terre" width="77" height="55">
            <input type="file" name="image" class="form-control" ></div>
            <div class="form-group">
           <label > صورة  البنر   </label>
           <img class="wp-post-image img-rounded" src="' . asset('images/banners') . '/' . $boycotts->banner . '" alt="Cinque Terre" width="77" height="55">
            <input type="file" name="banner" class="form-control" ></div>';
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Admin\boycott_company  $boycott_company
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        $this->validate($request, [
            'name' => 'required|string|unique:sub_categories,name,'.$request->id,
         ]);
        $boycotts = boycott_company::find($request->id);
        $boycotts->name = $request->name;
        if ($request->image != null) {
            $old_image = 'images/boycotts/' . $boycotts->image;
            if (file_exists($old_image)) {
                @unlink($old_image);
            }
            $truck_img = time() . '.' . $request->image->extension();
            $request->image->move(public_path('images/boycotts'), $truck_img);
            $boycotts->image = $truck_img;
        }
        if ($request->banner != null) {
            $old_banner = 'images/banners/' . $boycotts->banner;
            if (file_exists($old_banner)) {
                @unlink($old_banner);
            }
            $truck_banner = time() . '.' . $request->banner->extension();
            $request->banner->move(public_path('images/banners'), $truck_banner);
            $boycotts->banner = $truck_banner;
        }
        $boycotts->save();
    }
    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Admin\boycott_company  $boycott_company
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $imagePath = boycott_company::find($id);
        $old_image = 'images/boycotts/' . $imagePath->image;
        if (file_exists($old_image)) {
            $imagePath->delete();
            @unlink($old_image);
            echo '<p style="color:red"> تم الحذف *  </p>';
        } else {
            $imagePath->delete();
            echo '<p style="color:red"> تم الحذف </p>';
        }
    }

}
