<?php

namespace App\Http\Controllers\BackEnd;

use App\Http\Controllers\Controller;
use App\Models\Presence;
use App\Models\PresenceType;
use App\Models\Shift;
use App\Models\User;

use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;



class ReportController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {

        // $presence_type_id = $request->has('presence_type_id') ? $request->get('presence_type_id') :null;
        // $circle = $request->has('circle') ? $request->get('circle') :null;
        // $eligible = $request->has('eligible') ? $request->get('eligible') :null;
        // $level = $request->has('level') ? $request->get('level') :null;
        // $continuity = $request->has('continuity') ? $request->get('continuity') :null;
        // $date_entry = $request->has('date_entry') ? $request->get('date_entry') : null;
        // $exit_date_entry = $request->has('exit_date_entry') ? $request->get('exit_date_entry') : null;

        $user_id = $request->user_id;
        $presence_type_id = $request->presence_type_id;
        $eligible = $request->eligible;
        $continuity = $request->continuity;
        $date_entry = $request->date_entry;
        $exit_date_entry = $request->exit_date_entry;
        //  dd($presence_type_id);

        $query = Presence::query();
        if ($user_id) {
            // dd($presence_type_id);
            $query->where('user_id', $user_id);
            // $reportview->where('crewprogram_isdisabled', '=',0);
            //  $query->where('presence_type_id','=',4);
        }
        
        if ($presence_type_id) {
            // dd($presence_type_id);
            $query->where('presence_type_id', $presence_type_id);
            // $reportview->where('crewprogram_isdisabled', '=',0);
            //  $query->where('presence_type_id','=',4);
        }

        if ($date_entry && !$exit_date_entry) {
            //  dd($date_entry);
            $query->whereDate('date', '>=', $date_entry);
        }

        if (!$date_entry && $exit_date_entry) {
            //  dd($date_entry);
            $query->whereDate('date', '=', $exit_date_entry);
        }
        if ($date_entry && $exit_date_entry) {
            $query->whereBetween('date', [$date_entry, $exit_date_entry]);
            // $query->where('exit_date_entry', '<=', $request->input('exit_date_entry'));
        }

        // $query->with('whereHasUser', function ($q)  {$q->where('circle',3); });
        // if ($circle) {
        //     $query->whereHas('user', function ($q) use ($circle) {
        //         // dd($query->circle);
        //         $q->where('circle', $circle);
        //     });

        //     // $query->with('whereHasUser', function ($q) use ($request) {$q->where('circle',$request->circle); });
        // }

        if ($eligible) {
            $query->whereHas('user', function ($q) use ($eligible) {
                // dd($query->eligible);
                $q->where('eligible', $eligible);
            });
        }


        // if ($level) {
        //     $query->whereHas('user', function ($q) use ($level) {
        //         // dd($query->level);
        //         $q->where('level', $level);
        //     });
        // }


        // $query = Presence::with('user');
        // $query->whereHas('user', function ($query)   {
        //     return $query->where('circle', 3);
        // });
        // $posts = $query->get();

        // if ($request->has('date_entry') && $request->has('exit_date_entry')) {
        //     $query->orWhere(function ($query) use ($request){
        //         $query->Where('price', '>=', $request->input('price_start'));
        //         $query->Where('price', '<=', $request->input('price_end'));
        //     });
        // }

        $presences_user = $query->get();
        // $presences_user =$query->get();
        // $users= User::all();
        return view('back.reports.index', compact('presences_user', 'presence_type_id', 'circle', 'eligible', 'level', 'continuity', 'date_entry', 'exit_date_entry','user_id'));
        // return view('back.reports.index', compact(['reports']));
    }
    public function index1(Request $request)
    {
        $user_id = $request->has('user_id') ? $request->get('user_id') : null;
        $presence_type_id = $request->has('presence_type_id') ? $request->get('presence_type_id') : null;
        $continuity = $request->has('continuity') ? $request->get('continuity') : null;
        $date_entry = $request->has('date_entry') ? $request->get('date_entry') : null;
        $exit_date_entry = $request->has('exit_date_entry') ? $request->get('exit_date_entry') : null;
        $presences_user = Presence::all();
        // $users= User::all();
        return view('back.reports.index1', compact('presences_user', 'presence_type_id', 'circle', 'eligible', 'level', 'continuity', 'date_entry', 'exit_date_entry','user_id'));

        // $users= User::all();
        // return view('back.reports.index1', compact(['reports']));
    }

    public function gitfilter(Request $request)
    {

        // $presence_type_id = $request->presence_type_id;
        // $circle = $request->circle;
        // $eligible = $request->eligible;
        // $level = $request->level;
        // $continuity = $request->continuity;
        // $date_entry = $request->date_entry;
        // $exit_date_entry = $request->exit_date_entry;



        $presence_type_id = $request->has('presence_type_id') ? $request->get('presence_type_id') : [];
        // $circle = $request->has('circle') ? $request->get('circle') : [];
        // $eligible = $request->has('eligible') ? $request->get('eligible') : [];
        // $level = $request->has('level') ? $request->get('level') : [];
        $continuity = $request->has('continuity') ? $request->get('continuity') : [];
        $date_entry = $request->has('date_entry') ? $request->get('date_entry') : null;
        $exit_date_entry = $request->has('exit_date_entry') ? $request->get('exit_date_entry') : null;

        $query = Presence::query();

        if ($request->has('date_entry')) {
            $query->whereBetween('price', [0, 500]);
            return $query->where('date_entry', $request->input('circle'));
        }

        if ($request->has('presence_type_id')) {
            return $query->where('presence_type_id', $request->input('presence_type_id'));
        }

        if ($request->has('category_name')) {
            $query->whereHas('category', function ($q) use ($request) {
                $q->orWhereIn('name',  $request->input('category_name'));
            });
        }


        if ($request->has('published')) {
            $query->where('published', (bool) $request->input('published'));
        }

        if ($request->has('circle')) {
            $query->whereHas('user', function ($query) use ($request) {
                return $query->where('presence_type_id', $request->input('presence_type_id'));
            });
        }

        if ($request->has('tags')) {
            $query->whereHas('tag', function ($query) use ($request) {
                return $query->where('tag_slug', $request->input('tags'));
            });
        }
        $presences_user = $query->get();

        return view('back.reports.report', compact('presences_user', 'presence_type_id', 'circle', 'eligible', 'level', 'continuity', 'date_entry', 'exit_date_entry'));
        // return view('posts',compact('posts'));

    }
    public function create_presence_type_id($id, $name)
    {






        // $presences_type = PresenceType::find($id);
        // dd($id);

        // $presences_type =  DB::table('users')->filter($name)->whereNotIn('id', Presence::where("presence_type_id",$id)->pluck("user_id")->toArray())->get();
        $presences_type = User::where('active', 0)->filter(['id' => '1', 'name' => 'maza'])->get();
        // $presences_type = Presence::where('presence_type_id',$id)->filter($name)->with('user')->get();
        // $users= User::where('active',0)->get();
        // $users= User::all();
        // $presences_type = Presence::where('presence_type_id',$id)->get();
        // $users= User::where('active',0)->get();
        // $users= User::all();
        // DB::table('user')                 
        //     ->select('id','name')
        //     ->whereNotIn('id', DB::table('presences')->select('user_id')->where('presence_type_id', '=', $id)->get()->toArray())->get();
        // $id=1;
        // $presences_type = DB::table('users')->select('id','name')->whereNotIn('id', DB::table('presences')->select('user_id')->where('id', '=', $id)->get()->toArray())->get();
        $presences_type =  DB::table('users')->select('id', 'name')->whereNotIn('id', Presence::where("presence_type_id", $id)->pluck("user_id")->toArray())->get();
        return view('back.presences.table', compact(['presences_type']));
    }

    public function reportcreate()
    {

        return view('back.reports.report');
    }

    public function reportcreate1()
    {

        return view('back.reports.report1');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {



        $query = Presence::with('user');
        $query->whereHas('user', function ($query) {
            return $query->where('circle', 3);
        });
        $posts = $query->get();





        $query = Presence::query();

        if ($request->has('title')) {
            $query->where('title', 'LIKE', '%' . $request->input('title') . '%');
        }

        if ($request->has('published')) {
            $query->where('published', (bool) $request->input('published'));
        }

        if ($request->has('category')) {
            $query->whereHas('category', function ($query) use ($request) {
                return $query->where('category_slug', $request->input('category'));
            });
        }

        if ($request->has('tags')) {
            $query->whereHas('tag', function ($query) use ($request) {
                return $query->where('tag_slug', $request->input('tags'));
            });
        }
        $posts = $query->get();

        // return view('back.presences.table', compact(['presences_type']));

        // return view('posts',compact('posts'));


        // return view('back.presences.index1', compact(['presences','users']));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
