<?php

namespace App\Http\Controllers\BackEnd;

use App\Http\Controllers\Controller;

use App\Models\boycott_category;
use App\Traits\UploadTrait;
use Illuminate\Http\Request;




class BoycottCategoryController extends Controller
{

    use UploadTrait;
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function boycott_categories_eye($id)
    {

        $affected = boycott_category::find($id);
        if ($affected->active == 1) {
            $affected->active = 0;
            $affected->save();
            echo ' <i style="color: red;" class="ti-eye"></i>';
        } else {
            $affected->active = 1;
            $affected->save();
            echo '<i class="ti-eye"></i>';
        }
    }
    public function index1()
    {
        $boycott_categories = boycott_category::all();
        return view('back.boycott_categories.index1', compact('boycott_categories'));
    }

    public function index()
    {
        $boycott_categories = boycott_category::all();
        return view('back.boycott_categories.index', compact('boycott_categories'));
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {


    //     name
    //     details
    //     reason_boycott
    //     name_en
    //     details_en
    //     reason_boycott_en
    //     image
    //    active

        echo '
        <div class="form-group">
        <label >  اسم الصنف</label>
        <input id="name" name="name" type="text" class="form-control" placeholder="اسم الصنف ">
        </div>



        <div class="form-group">
        <label >اسم الصنف بالغة الانجليزية    </label>
        <input  id="name_en" name="name_en"  class="form-control" type="text" value=""  placeholder="  اسم الصنف بالغة الانجليزية ">
        </div>

        <div class="form-group">
        <label > أرفاق شعار الصنف </label>

        <div class="col-lg-12">
        <div class="custom-file">
            <input type="file" id="image" name="image"  class="custom-file-input"
                id="customFile">
            <label class="custom-file-label" for="customFile"> أرفاق شعار الصنف</label>
        </div>
    </div>
        </div>';

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */




    public function store(Request $request)
    {



        $this->validate($request, [
            'name' => 'required|string|unique:boycott_categories,name',
        ]);
        $boycott_categories = new boycott_category();
        $boycott_categories->name = $request->name;
        $boycott_categories->name_en = $request->name_en;
        if ($request['image'] != null)
        $boycott_categories->image = $this->storeImage($request['image'], 'images/boycott_categories');

        $boycott_categories->save();

        //  return redirect()->route('boycott_categories.index')->with('success', 'لقد تم انشاء  ');
    }


    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {



        $boycott_category = boycott_category::find($id);



        echo '
        <input type="hidden"  id="id" name="id"  value="' . $id . '">
        <div class="form-group">
        <label >  اسم الصنف</label>
        <input id="name" name="name" type="text" value="' . $boycott_category->name . '"  class="form-control" placeholder="اسم الصنف ">
        </div>
        <div class="form-group">
        <label >اسم الصنف بالغة الانجليزية    </label>
        <input  id="name_en" name="name_en"  class="form-control" type="text"  value="' . $boycott_category->name_en . '"  placeholder="  اسم الصنف بالغة الانجليزية ">
        </div>
        <div class="row">
        <div class="col-lg-8">
        <div class="custom-file">
            <input type="file" id="image" name="image"   class="custom-file-input"
                id="customFile">
            <label class="custom-file-label" for="customFile"> أرفاق شعار الصنف</label>
        </div>
    </div>

    <div class="col-lg-4">
    <div class="custom-file">
            <img class="wp-post-image img-rounded"
            src="' . $boycott_category->image . ' "alt="product" width="60">
             </div>
        </div>
    </div>';
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        $this->validate($request, [
           'name' => 'required|string|unique:boycott_categories,name,' . $request->id,
           'details' => 'required',
        ]);

        $boycott_categories = boycott_category::find($request->id);
        $boycott_categories->name = $request->name;
        $boycott_categories->name_en = $request->name_en;
        if ($request['image'] != null)
        $boycott_categories->image = $this->updateImage($request['image'], 'images/boycott_categories',$boycott_categories->image);

        $boycott_categories->save();

        //  return redirect()->route('boycott_categories.index')->with('success', 'لقد تم انشاء  ');

         }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $imagePath = boycott_category::find($id);
            $imagePath->delete();
            echo '<p style="color:red"> تم الحذف *  </p>';
    }
}
