<?php

namespace App\Http\Controllers\BackEnd;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Location;
class LocationController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function locations_eye($id)
    {

        $affected = Location::find($id);
        if ($affected->active == 1) {
            $affected->active = 0;
            $affected->save();
            echo ' <i style="color: red;" class="ti-eye"></i>';
        } else {
            $affected->active = 1;
            $affected->save();
            echo '<i class="ti-eye"></i>';
        }
    }
    public function index1()
    {
        $locations = Location::all();
        return view('back.locations.index1', compact('locations'));
    }

    public function index()
    {
        $locations = Location::all();
        return view('back.locations.index', compact('locations'));
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        echo '
        <div class="form-group">
        <label >  اسم المنطقة</label>
        <input id="name" name="name" type="text" class="form-control" placeholder="اسم المنطقة ">
        </div>
        <div class="form-group">
        <label > كود المنطقة </label>
        <input id="code" name="code" type="text" class="form-control" placeholder=" كود المنطقة ">
        </div>
        <div class="form-group">
        <label >اسم المنطقة بالغة الانجليزية    </label>
        <input  id="name_en" name="name_en"  class="form-control" type="text" value=""  placeholder="  اسم المنطقة بالغة الانجليزية ">
      </div>
      <div class="form-group">
<label > نقطةالطور </label>
        <input id="latitude" name="latitude" type="text" class="form-control" placeholder="نقطةالطور">
 </div><div class="form-group">
 <label > نقطه العرض  </label>
         <input id="longitude" name="longitude" type="text" class="form-control" placeholder=" نقطه العرض">
  </div> ';

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */




    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required|string|unique:locations,name',
            'code' => 'required',
        ]);
        $locations = new Location();
        $locations->name = $request->name;
        $locations->code = $request->code;
        $locations->name_en = $request->name_en;
        $locations->latitude = $request->latitude;
        $locations->longitude = $request->longitude;
        $locations->save();

        //  return redirect()->route('locations.index')->with('success', 'لقد تم انشاء  ');
    }


    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {



        $Location = Location::find($id);

        echo '
        <input type="hidden"  id="id" name="id"  value="' . $id . '">
        <div class="form-group">
        <label >اسم المنطقة  </label>
        <input id="name" name="name" type="text" value="' . $Location->name . '" class="form-control" placeholder="اسم المنطقة ">
        </div>
        <div class="form-group">
        <label > كود المنطقة  </label>
        <input id="code" name="code" type="text" value="' . $Location->code . '" class="form-control" placeholder="كود المنطقة  ">
        </div>
        <div class="form-group">
        <label > اسم المنطقة بالغة الانجليزية  </label>
        <input  id="name_en" name="name_en"  class="form-control"value="' . $Location->name_en . '"  type="text"  placeholder="اسم المنطقة بالغة الانجليزية ">
      </div>
      <div class="form-group">
     <label > نقطةالطور </label>
        <input id="latitude" name="latitude" type="text" class="form-control" value="' . $Location->latitude . '" placeholder="نقطةالطور">
 </div><div class="form-group">
 <label > نقطه العرض  </label>
         <input id="longitude" name="longitude" type="text" class="form-control" value="' . $Location->longitude . '" placeholder=" نقطه العرض">
  </div> ';

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request)
    {
        $this->validate($request, [
           'name' => 'required|string|unique:locations,name,' . $request->id,
           'code' => 'required',
        ]);

        $locations = Location::find($request->id);
        $locations->name = $request->name;
        $locations->code = $request->code;
        $locations->name_en = $request->name_en;
        $locations->latitude = $request->latitude;
        $locations->longitude = $request->longitude;
        $locations->save();
         }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $imagePath = Location::find($id);
            $imagePath->delete();
            echo '<p style="color:red"> تم الحذف *  </p>';
    }
}
