<?php






namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable, HasRoles;
    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    // protected $fillable = [
    //     'user_name', 'fname', 'lname', 'phone', 'email', 'password', 'profile'
    // ];
    public function receivesBroadcastNotificationsOn()
    {
        return 'users.' . $this->id;
    }
    
     protected $fillable = [
        'name',
        'username',
        'phone',
        'email',
        'password',
        'active',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    // public function shift()
    // {
    //     return $this->belongsTo(Shift::class);
    // }

    // public function presence()
    // {
    //     return $this->hasMany(Presence::class);
    // }

 
}
